<?php
header("content-type:text/html; charset=utf-8");
class Gateway_Ipasspaydirect_Block_Redirect extends Mage_Core_Block_Template {
    protected $_order;
    public function getOrder() {
        if ($this->_order == null) {
            $session = Mage::getSingleton('checkout/session');
            $this->_order = Mage::getModel('sales/order');
            $this->_order->loadByIncrementId($session->getLastRealOrderId());
        }
        return $this->_order;
    }
    protected function _toHtml() {
        $media_url = Mage::getBaseUrl('media');
        $standard = Mage::getModel('ipasspaydirect/payment');

        // execute the page and then jump.
        $htmldiv = '<style type="text/css">#t01 {margin: auto;margin-top: 150px;text-align: center;border: 1px solid #a1a1a1;padding: 10px 40px;width: 500px;height: 110px;border-radius: 6px;-moz-border-radius: 6px;box-shadow: 3px 3px 3px #888888;border-radius: 6px;-moz-border-radius: 6px;box-shadow: 3px 3px 3px #888888;-moz-box-shadow: 3px 3px 3px #888888;}</style>';
        $htmldiv .= '<div id="t01"><br /><br /><img src="' . $media_url . '/ipasspaydirect_logo/loading.gif" /><br /><br /><span>Please wait,transaction processing ...</span></div>';
        echo $htmldiv;
        //$strValue = $standard->setOrder($this->getOrder())->getStandardCheckoutFormFields();
        $curlPost = $standard->setOrder($this->getOrder())->getStandardCheckoutFormFields();

        //$strValue = $strValue . "&card_no=" . urlencode($cardid) . "&card_cvv=" . urlencode($cvv2) . "&card_ex_year=" . urlencode($ex_year) . "&card_ex_month=" . urlencode($ex_month);
        $gateway_url = $standard->getIpasspaydirectUrl(); // Payment gateway url

        $url_back = $standard->getBackUrl(); // success return url
        $response = $this->curlSend($gateway_url,$curlPost,1);

        $result = json_decode($response,true);
        if ($result != '') {
            if($result["data"]["pay_url"] != '') {
                //3D channel payment
                $redirect_url = urldecode($result["data"]["pay_url"]);
                header("Location: $redirect_url");
                exit;
            } else {  //2D channel payment
                if ($result['errcode'] != 0) {
                    $status = $result['errcode'];
                    $info = $result['errmsg'];
                    $oid1 = $curlPost['custom_data'];

                    $html = '<form action="' . $url_back . '" id="form1" method="post">';
                    $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
                    $html .= '<input type="hidden" name="status" value="' . $status . '" />';
                    $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';

                } else {
                    $status = $result['errcode'];
                    $order_status = $result['data']['order_status'];
                    $gateway_order_no = $result['data']['gateway_order_no'];
                    $order_no = $result['data']['order_no'];
                    $order_amount = $result['data']['order_amount'];
                    $order_currency = $result['data']['order_currency'];
                    $signature = $result['data']['signature'];
                    $notification_url = $result['data']['syn_url'];
                    $info = $result['data']['info'];
                    //$oid1 = $this->getOrder()->getId();
                    $oid1 = $curlPost['custom_data'];

                    $html = '<form action="' . $url_back . '" id="form1" method="post">';
                    $html .= '<input type="hidden" name="status" value="' . $status . '" />';
                    $html .= '<input type="hidden" name="order_status" value="' . $order_status . '" />';
                    $html .= '<input type="hidden" name="gateway_order_no" value="' . $gateway_order_no . '" />';
                    $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
                    $html .= '<input type="hidden" name="order_no" value="' . $order_no . '" />';
                    $html .= '<input type="hidden" name="order_amount" value="' . $order_amount . '" />';
                    $html .= '<input type="hidden" name="order_currency" value="' . $order_currency . '" />';
                    $html .= '<input type="hidden" name="signature" value="' . $signature . '" />';
                    $html .= '<input type="hidden" name="notification_url" value="' . $notification_url . '" />';
                    $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';
                }
            }
            $html .= '<script type="text/javascript">
					setTimeout("redct()", 3000);
					function redct(){
					    document.getElementById("form1").submit();
					}</script>';
            echo $html;exit;

        } else {
            // pay back is empty
            $info = "Pay back is empty, please pay again.";
            $status = 'empty';
            $oid1 = $curlPost['custom_data'];

            $html = '<form action="' . $url_back . '" id="form1" method="post">';
            $html .= '<input type="hidden" name="oid1" value="' . $oid1 . '" />';
            $html .= '<input type="hidden" name="status" value="' . $status . '" />';
            $html .= '<input type="hidden" name="info" value="' . $info . '"/></form>';
            $html .= '<script type="text/javascript">
					setTimeout("redct()", 1000);
					function redct(){
					    document.getElementById("form1").submit();
					}</script>';
            echo $html;exit;
        }

    }

    protected function curlSend($process_gateway, $data_arr, $type = 1) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $process_gateway);
        curl_setopt($ch, CURLOPT_POST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data_arr));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }
}
?>
